
import track21.*;

import waba.ui.*;
import waba.fx.*;
import waba.sys.*;
import waba.util.*;

public class MainGUI extends MainWindow
{
  public static String progName="Track2";
  public static String progVersion="1.2";

  public static final int PRODUCT_FULL=0, PRODUCT_TIMEIT=1,
    PRODUCT_STUDENT=5, PRODUCT_MONEY=6,
    PRODUCT_HABIT=7, PRODUCT_PLOTIT=8;

//choose one
  public static final int currentProduct=PRODUCT_FULL;      // last release: v1.2 20030218
//  public static final int currentProduct=PRODUCT_TIMEIT;  // last release: v1.1 20020225
//  public static final int currentProduct=PRODUCT_MONEY;
//  public static final int currentProduct=PRODUCT_STUDENT;
//  public static final int currentProduct=PRODUCT_HABIT;   // last release: v1.1 20020223
//  public static final int currentProduct=PRODUCT_PLOTIT;  // last release: v1.1 20020227

  TabPanel mainTabPanel;
  ListBox dataListBox;
  Button dateButton, enterButton, delButton, timerButton, incButton;
  PushButtonGroup keypadPushBtnGrp;
  Calendar cal;
  Edit dataEdit, commentEdit;
  Label commentLbl, dataLbl;
  LineGraph graph;
  LineFit fit; // the fitting object
  Timer guiTimer;
  boolean timerMode=false;
  DateTimeStamp startDTS=new DateTimeStamp();
  boolean timerButtonFlashState=false;

  NewDatabaseWindow ndw;
  GraphOptionsWindow gow;

  String alphaNum="abcdefghijklmnopqrstuvwxyz1234567890";
  String numOnly="1234567890.";

  MenuBar mbar;
  String mbarList1[]={"Tools","Delete DB","Export Data","Import Data","Purge 50%","Exit"};
  String mbarList2[]={"Help","-","Register","About"};
  String mbarList3[]={"+++","PC","Graph Options"};
  static final int MBAR_DELETE_DB=001, MBAR_IMPORT=003, MBAR_EXPORT=002, MBAR_PURGE_50=004, MBAR_EXIT=005,
    MBAR_GRAPH_OPT=202, MBAR_REGISTER=102, MBAR_ABOUT=103, MBAR_ADMIN=200, MBAR_SHOWPC=201;

  ComboBox dbComboBox;
  MessageBox delDBmessageBox;

  String keypadStr[]={"1","2","3","4","5","6","7","8","9","0",".","C"};
  String tabStr[]={"Data","Graph", "Fit"};

  String dbListStr[];

  String dataListStr[]=null;

  TrackData td=new TrackData();
  CatalogIO cio=new CatalogIO();
  MemoPadIO mio=new MemoPadIO();

  Date tmpDate;
  String tmpComment;
  float tmpValue;

  public MainGUI()
  {
  }

  public void onStart()
  {
    boolean nagOnSplash=false;

    switch (currentProduct)
    {
      case PRODUCT_HABIT:
        progName="Track2Habit";
        nagOnSplash=true;
        break;
      case PRODUCT_MONEY:
        progName="Track2Money";
        break;
      case PRODUCT_STUDENT:
        progName="Track2Student";
        break;
      case PRODUCT_TIMEIT:
        progName="Track2TimeIt";
        break;
      case PRODUCT_PLOTIT:
        progName="Track2PlotIt";
        break;
      case PRODUCT_FULL:
        break;
    }

    mbar=new MenuBar(new String[][]{mbarList1,mbarList2});
    setMenuBar(mbar);

    dbComboBox=new ComboBox(dbListStr);
    add(dbComboBox);
    dbComboBox.setRect(LEFT+45,TOP,80,PREFERRED);
    cio.readDBlist();
    rebuildDBlistBox();

    mainTabPanel=new TabPanel(tabStr);
    add(mainTabPanel);
    mainTabPanel.setRect(LEFT,AFTER+2,FILL,FILL);

    Container c=mainTabPanel.getPanel(0);

    dataListBox=new ListBox(dataListStr);
    c.add(dataListBox);
    dataListBox.setRect(LEFT,TOP,FILL,80);

    keypadPushBtnGrp=new PushButtonGroup(keypadStr,false,-1,-1,8,1,true,PushButtonGroup.BUTTON);
    c.add(keypadPushBtnGrp,CENTER,AFTER+2);
    keypadPushBtnGrp.setCursorColor(Color.WHITE);

    dataLbl=new Label("Data");
    c.add(dataLbl,LEFT+2,AFTER+2,keypadPushBtnGrp);

    dataEdit=new Edit();
    c.add(dataEdit);
    dataEdit.setRect(AFTER+2,SAME,40,PREFERRED,dataLbl);
    dataEdit.setValidChars(numOnly);

    commentLbl=new Label("Comment");
    c.add(commentLbl,AFTER+6,SAME,dataEdit);

    commentEdit=new Edit();
    c.add(commentEdit);
    commentEdit.setRect(AFTER+2,SAME,40,PREFERRED,commentLbl);

    timerButton=new Button("Start Timer");
    c.add(timerButton);
    timerButton.setRect(LEFT,AFTER+5,PREFERRED,PREFERRED, dataLbl);

    tmpDate=new Date();
    dateButton=new Button(td.dateIntToString(tmpDate.getDateInt()));
    c.add(dateButton,LEFT+55,SAME,timerButton);

    enterButton=new Button("Enter");
    c.add(enterButton,AFTER+2,SAME,dateButton);

    delButton=new Button("Del");
    c.add(delButton);
    delButton.setRect(RIGHT,SAME,PREFERRED,SAME);

    c=mainTabPanel.getPanel(1);
    graph=new LineGraph();
    c.add(graph);
    graph.setRect(0,0,FILL,FILL);

    //set up the fit panel
    c = mainTabPanel.getPanel(2);
    fit = new LineFit(this, graph);
    c.add(fit);
    fit.onStart();


/*    if(currentProduct==PRODUCT_HTWT_BABY && cio.getDBcount()==0)  //COMMENT OUT IN PRODUCTION
    {
      String tmpList[]={    //create reference databases for data import
        "HT0P10X","HT0P50X","HT0P90X",
        "HT0P10Y","HT0P50Y","HT0P90Y",
        "WT0P10X","WT0P50X","WT0P90X",
        "WT0P10Y","WT0P50Y","WT0P90Y"};
      for (int i = 0; i < tmpList.length; i++)
      {
        cio.addDBtoList(tmpList[i]);
      }
    }
    else
    if(currentProduct==PRODUCT_HTWT_KID && cio.getDBcount()==0)   //COMMENT OUT IN PRODUCTION
    {
      String tmpList[]={    //create reference databases for data import
        "HT24P10X","HT24P50X","HT24P90X",
        "HT24P10Y","HT24P50Y","HT24P90Y",
        "WT24P10X","WT24P50X","WT24P90X",
        "WT24P10Y","WT24P50Y","WT24P90Y"};
      for (int i = 0; i < tmpList.length; i++)
      {
        cio.addDBtoList(tmpList[i]);
      }
    }

    if(currentProduct==PRODUCT_HTWT_BABY)
    {
      p10=new TrackData();
      p50=new TrackData();
      p90=new TrackData();
      CatalogIO cioTmp=new CatalogIO();
      cioTmp.readDB("HT0P10X",p10);
      cioTmp.readDB("HT0P50X",p50);
      cioTmp.readDB("HT0P90X",p90);
    }
*/
    changeToExistingDB();

    configProduct();
  }

   public void onEvent(Event event)
   {
//      Vm.debug("Main OnEvent: ev="+event.toString()+" EvTarget="+event.target);
      switch (event.type)
      {
         case ControlEvent.TIMER:
            if((event.target!=commentEdit)&&(event.target!=dataEdit)) //make certain edit isn't generating timer event
            {
              if(guiTimer.triggered)   //is it 1 sec timer for GUI update?
              {
                int diffS=startDTS.minus(new DateTimeStamp()).getTotalMin();
                dataEdit.setText(Convert.toString(diffS));
    //            Vm.debug("TS1="+startDTS.getTimeStampInt()+" TS2="
    //              +(new DateTimeStamp()).getTimeStampInt()+" diffSecs="+diffSecs);
                timerButtonFlashState=!timerButtonFlashState;
                if(timerButtonFlashState)
                  timerButton.setText("Stop Timer");
                else
                  timerButton.setText("********");
              }
            }
            break;
         case ControlEvent.PRESSED:
//            Vm.debug("Pressed");
            if (event.target == dateButton)
            {
//              Vm.debug("DateBtn");
              if(cal==null)
                cal=new Calendar();

              popupModal(cal);
            }
            else
            if(event.target==dataListBox)
            {
              tmpDate=new Date(td.getDateInt(dataListBox.getSelectedIndex()));
              dateButton.setText(td.dateIntToString(tmpDate.getDateInt()));
            }
            else
            if (event.target == keypadPushBtnGrp)
            {
              if(keypadPushBtnGrp.getSelected()<keypadStr.length &&
                keypadPushBtnGrp.getSelected()>=0)   //sometime getSelect is out of bounds!
              {
                if(keypadStr[keypadPushBtnGrp.getSelected()].compareTo("C")==0)
                {
                  dataEdit.setText("");
                  commentEdit.setText("");
                }
                else
                  dataEdit.setText(dataEdit.getText()+keypadStr[keypadPushBtnGrp.getSelected()]);
              }
            }
            else
            if (event.target == enterButton)
            {
//              Vm.debug("EnterBtn");
              commitData();
            }
            else
            if (event.target == delButton)
            {
              if (dbComboBox.getSelectedIndex()!=0)
              {
                int tmpIdx=dataListBox.getSelectedIndex();
                if(tmpIdx>=0 & td.getNumPts()>0)
                  td.removeData(tmpIdx);
                td.getGraphOptions().setPrecision(td.getMaxPrecision());
                rebuildDataListBox();
                saveTrackData();
              }
            }
            else
            if(event.target==timerButton)
            {
              if (dbComboBox.getSelectedIndex()!=0)
              {
              //              Vm.debug("Timer Started");
                timerMode=!timerMode;

                if(timerMode)   //timer has started
                {
                  startTimer(new DateTimeStamp());
                }
                else            //timer has been stopped
                {
                  stopTimer();
                  commentEdit.setText(commentEdit.getText()
                    +startDTS.getTimeStampString()+"-"
                    +(new DateTimeStamp().getTimeStampString()));
                  cio.removeDBtimeStamp(getCurDB());  //delete timestamp file (it isn't needed)
                  commitData();
                  commentEdit.setText("");
                  dataEdit.setText("");
                }
              }
              else
              {
                popNoDBmBox();
              }
            }
            else
            if(event.target==incButton)
            {
              dataEdit.setText("1");
              commitData();
            }
            else
            if(event.target==dbComboBox)
            {
              if(dbComboBox.getSelectedIndex()==0)  //create new DB
              {
                  stopTimer();
                  ndw=new NewDatabaseWindow();
                  ndw.setRect(CENTER,CENTER,140,60);
                  ndw.setBorderStyle(Window.ROUND_BORDER);
                  ndw.setTitle("Enter New Database Name");
                  popupModal(ndw);
              }
              else    //user has selected a different database
              {
                changeToExistingDB();
              }
            }

            break;

          case ControlEvent.WINDOW_CLOSED:
            if(event.target==cal)
            {
            	if (cal.canceled == false)
            	{
            	    tmpDate = null;
                	tmpDate = cal.getSelectedDate();
                	//calendar seems to have a bug that it returns a null
                	//date if clear is pressed
                	if (tmpDate != null)
 	              	  dateButton.setText(td.dateIntToString(tmpDate.getDateInt()));
 	            }
            }
            if(event.target==delDBmessageBox)   //deleteDB confirm box
            {
              if (delDBmessageBox.getPressedButtonIndex()==0) //pressed yes!
              {
                  cio.removeDBfromList(dbComboBox.getSelectedItem().toString());
                  cio.readDBlist();
                  rebuildDBlistBox();
                  changeToExistingDB();
              }
            }
            else
            if(event.target==ndw)
            {
              if (ndw.getNewDBname().length()>0)
              {
                cio.addDBtoList(ndw.getNewDBname());
                rebuildDBlistBox();
                td=new TrackData();
//                graph.setData(td);
                graph.setData(new TrackData[]{td});
                fit.setData(td);  //update fit data
                rebuildDataListBox();
                saveTrackData();
                mainTabPanel.setActiveTab(0);
              }
              ndw=null;
              rebuildDBlistBox();
              loadTrackData();
              rebuildDataListBox();
            }
            else
            if(event.target==gow)
            {
              gow.setGraphOptionsFromGUI();
              saveTrackData();  //in case graph options were changed
              gow=null;
            }
            else
            if(event.target==mbar)
            {
              switch(mbar.getSelectedMenuItem())
              {
                case MBAR_DELETE_DB:
                  if (dbComboBox.getSelectedIndex()!=0)
                  {
                    delDBmessageBox=new MessageBox("Confirm Delete","Do you really want|"
                      +"to delete this database?",new String[]{"Yes","No"});
                    popupModal(delDBmessageBox);
                  }
                  else
                  {
                    popNoDBmBox();
                  }
                  break;
                case MBAR_GRAPH_OPT:
                  if (dbComboBox.getSelectedIndex()!=0)
                  {
                    gow=new GraphOptionsWindow(td.getGraphOptions());
                    gow.setRect(LEFT,TOP,FILL,FILL);
                    gow.setBorderStyle(Window.ROUND_BORDER);
                    gow.setTitle("Graph Options");
                    mainTabPanel.setActiveTab(0);
                    popupModal(gow);
                  }
                  else
                  {
                    popNoDBmBox();
                  }
                  break;
                case MBAR_ABOUT:
                    about();
//                  float v1=10, v2=3.1415f;
//                  Vm.debug("v1a="+Convert.toString(v1));
//                  Vm.debug("v1b="+Convert.toString(v1,0));
//                  Vm.debug("v1c="+Convert.toString(v1,1));
//                  Vm.debug("v1d="+Convert.toString((int)v1));
//                  Vm.debug("v2a="+Convert.toString(v2));
//                  Vm.debug("v2b="+Convert.toString(v2,0));
//                  Vm.debug("v2c="+Convert.toString(v2,1));
//                  Vm.debug("v2d="+Convert.toString(v2,3));
                  break;
                case MBAR_EXIT:
                  exit(0);
                  break;
                case MBAR_PURGE_50:
                  td.removeDataBeforeIdx(td.getNumPts()/2);
                  rebuildDataListBox();
                  saveTrackData();
                  break;
                case MBAR_IMPORT:
                  if (dbComboBox.getSelectedIndex()!=0)
                  {
                    TrackData tdTmp=mio.importData(dbComboBox.getSelectedItem().toString());
                    if(tdTmp!=null)
                    {
                      td=tdTmp;
                      td.getGraphOptions().setPrecision(td.getMaxPrecision());
                      rebuildDataListBox();
                      saveTrackData();
                    }
                    else
                    {
                      MessageBox mb=new MessageBox("Error","Import Failed!|Perhaps the memo \""
                        +dbComboBox.getSelectedItem().toString()+"\"|does not exist or is|"
                        +"in the wrong format.");
                      popupModal(mb);
                    }
                  }
                  else
                  {
                    popNoDBmBox();
                  }
                  break;
                case MBAR_EXPORT:
                  if (dbComboBox.getSelectedIndex()!=0)
                  {
                    mio.exportData(dbComboBox.getSelectedItem().toString(),td);
                    MessageBox mb=new MessageBox("Info","Data exported to memo \""
                      +dbComboBox.getSelectedItem().toString()+"\"");
                    popupModal(mb);
                  }
                  else
                  {
                    popNoDBmBox();
                  }
                  break;
              }
            }

      }
   }

  String getCurDB()
  {
    return dbComboBox.getSelectedItem().toString();
  }

  void rebuildDataListBox()
  {
    dataListStr=new String[td.getNumPts()];
    for (int i = 0; i < td.getNumPts(); i++)
    {
      dataListStr[i]=td.buildTableStr(i);
    }
    dataListBox.removeAll();
    dataListBox.add(dataListStr);
  }

  void rebuildDBlistBox()
  {
//    Vm.debug("DBcount="+cio.getDBcount());
    dbListStr=new String[cio.getDBcount()+1];
    dbListStr[0]=new String("New Database");
    for (int i = 0; i < cio.getDBcount(); i++)
    {
//      Vm.debug("i="+i+" DBcount="+cio.getDBcount());
      dbListStr[i+1]=cio.getDBname(i);
    }
    dbComboBox.removeAll();
    dbComboBox.add(dbListStr);
    dbComboBox.select(cio.getDBcount());
  }

  void loadTrackData()
  {
    td=new TrackData();
//    if(currentProduct==PRODUCT_HTWT_BABY)
//      graph.setData(new TrackData[]{td,p10,p50,p90});
//    else
      graph.setData(new TrackData[]{td});
      fit.setData(td); //update the fit data
    if(dbComboBox.getSelectedIndex()!=0)
      cio.readDB(dbComboBox.getSelectedItem().toString(),td);
  }

  void saveTrackData()
  {
    cio.writeDB(dbComboBox.getSelectedItem().toString(),td);
  }

  void popNoDBmBox()
  {
    MessageBox mb=new MessageBox("Error","You must create a database first!|Tap on \"New Database\"");
    popupModal(mb);
  }

  void commitData()
  {
    if(dbComboBox.getSelectedIndex()==0)
    {
      popNoDBmBox();
    }
    else
    {
      tmpComment=commentEdit.getText();
      tmpValue=Convert.toFloat(dataEdit.getText());

      if(GraphOptions.calcPrecision(tmpValue)>td.getGraphOptions().getPrecision())
        td.getGraphOptions().setPrecision(GraphOptions.calcPrecision(tmpValue));

      td.addData(tmpDate.getDateInt(),tmpValue,tmpComment);

      String tmpStr=td.buildTableStr(td.getNumPts()-1);

  //              Vm.debug(tmpStr);
  //                td.debug();
      td.consolidateData();
      rebuildDataListBox();
      saveTrackData();
    }
  }

  void startTimer(DateTimeStamp dts)
  {
    timerMode=true;
    startDTS.setDateTimeStamp(dts);
    timerButton.setText("Stop Timer");
    cio.writeDBtimeStamp(startDTS,getCurDB());
//    Vm.debug("Starting timer NOW!");
    guiTimer=addTimer(1000);   //update GUIdata approx 1/sec
  }

  void stopTimer()
  {
    removeTimer(guiTimer);
    timerMode=false;
    timerButton.setText("Start Timer");
  }

  void changeToExistingDB()
  {
    stopTimer();
    loadTrackData();
    rebuildDataListBox();
    dataListBox.select(dataListBox.size()-1);
    mainTabPanel.setActiveTab(0);

    DateTimeStamp tmpDTS=cio.readDBtimeStamp(getCurDB()); //read timestamp
    if(tmpDTS!=null)  //if it exists, start timer
      startTimer(tmpDTS);
  }

  void about()
  {
    String helpText;

    helpText=new String(progName)+" v"+progVersion+"|"
      +"|(C)2003 Alan Stein|Info at www.medcosm.com||Program released under GPL|"
      +"No warranty provided||support open software!";

    String title="About "+progName;

    MessageBox mb1=new MessageBox(title,helpText);

    popupModal(mb1);
  }

  void configProduct()
  {
    switch (currentProduct)
    {
      case PRODUCT_HABIT:
//        Rect tmpRect=keypadPushBtnGrp.getRect();

        incButton=new Button("Habit Bar");
        Container c=mainTabPanel.getPanel(0);
        c.add(incButton);
        incButton.setRect(keypadPushBtnGrp.getRect());
        remove(keypadPushBtnGrp);

        dataLbl.setVisible(false);
        dataEdit.setVisible(false);
        dataEdit.setEnabled(false);
        commentLbl.setVisible(false);
        commentEdit.setVisible(false);
        commentEdit.setEnabled(false);
        enterButton.setVisible(false);
        enterButton.setEnabled(false);
        timerButton.setVisible(false);
        timerButton.setEnabled(false);
        repaint();
        break;
      case PRODUCT_MONEY:
      case PRODUCT_STUDENT:
      case PRODUCT_TIMEIT:
        keypadPushBtnGrp.setVisible(false);
        keypadPushBtnGrp.setEnabled(false);
        commentEdit.setVisible(false);
        commentEdit.setEnabled(false);
        commentLbl.setVisible(false);

        remove(keypadPushBtnGrp);
        repaint();
        break;
      case PRODUCT_PLOTIT:
        timerButton.setVisible(false);
        timerButton.setEnabled(false);
        break;
      case PRODUCT_FULL:
        break;
    }
  }

}
