package track21;

import waba.sys.*;
import waba.util.*;

public class DateTimeStamp
{
  int timeStamp;
  int dateStamp;

  public DateTimeStamp()
  {
    setTimeStampInt(getCurrentDateTime().getTimeStampInt());
    setDateStampInt(getCurrentDateTime().getDateStampInt());
  }

  public DateTimeStamp(int dateStampInt, int timeStampInt)
  {
    setDateStampInt(dateStampInt);
    setTimeStampInt(timeStampInt);
  }

  public DateTimeStamp getCurrentDateTime()
  {
    Time time=new Time();
    int tmpTSint=time.hour*10000+time.minute*100+time.second;
    return new DateTimeStamp(new Date().getDateInt(),tmpTSint);
  }

  public void setCurrentDateTime()
  {
    setTimeStampInt(getCurrentDateTime().getTimeStampInt());
    setDateStampInt(getCurrentDateTime().getDateStampInt());
  }

  public void setDateTimeStamp(DateTimeStamp dts)
  {
    setDateStampInt(dts.getDateStampInt());
    setTimeStampInt(dts.getTimeStampInt());
  }

  public void setTimeStampInt(int ts)
  {
    timeStamp=ts;
  }

  public void setDateStampInt(int ds)
  {
    dateStamp=ds;
  }

  public int getTimeStampInt()
  {
    return timeStamp;
  }

  public String getTimeStampString()
  {
    String hrStr;
    hrStr=Convert.toString(getHrs());
    if(getHrs()<10)
      hrStr="0"+hrStr;

    String minStr=Convert.toString(getMin());
    if(getMin()<10)
      minStr="0"+minStr;

    return(hrStr+":"+minStr);
  }

  int getTimeStampInt(int hr, int min, int sec)
  {
    return hr*10000+min*100+sec;
  }

  public int getDateStampInt()
  {
    return dateStamp;
  }

  public int getHrs()
  {
    int hr=getTimeStampInt()/10000;
    return hr;
  }

  public int getMin()
  {
    int dtsInt=getTimeStampInt()-getHrs()*10000;
    dtsInt=dtsInt/100;
    return dtsInt;
  }

  public int getSec()
  {
    int dtsInt=getTimeStampInt()-getHrs()*10000;
    dtsInt=dtsInt-getMin()*100;
    return dtsInt;
  }

  public int getYear()
  {
    int year=getDateStampInt()/10000;
    return year;
  }

  public int getMonth()
  {
    int dtsInt=getDateStampInt()-getYear()*10000;
    dtsInt=dtsInt/100;
    return dtsInt;
  }

  public int getDay()
  {
    int dtsInt=getDateStampInt()-getYear()*10000;
    dtsInt=dtsInt-getMonth()*100;
    return dtsInt;
  }

  public int getTotalSec()
  {
    int totalSec=getHrs()*3600+getMin()*60+getSec();
    return totalSec;
  }

  public int getTotalMin()
  {
    int totalMin=getHrs()*60+getMin();
    return totalMin;
  }

  public DateTimeStamp minus(DateTimeStamp dts1)  //usually dts1 occurs AFTER this.getTimeStampInt
  {
    int secDiff=dts1.getSec()-getSec();
    int minDiff=dts1.getMin()-getMin();
    int hrDiff=dts1.getHrs()-getHrs();

    int dayDiff=(new Date(dts1.getDateStampInt()).getJulianDay())-
                  (new Date(getDateStampInt()).getJulianDay());

    if(secDiff<0)
    {
      secDiff=secDiff+60;
      minDiff=minDiff-1;
    }
    if(minDiff<0)
    {
      minDiff=minDiff+60;
      hrDiff=hrDiff-1;
    }

    if(hrDiff<0)
    {
      hrDiff=hrDiff+24;
      dayDiff=dayDiff-1;
    }

    if(dayDiff>0)
    {
      hrDiff=hrDiff+dayDiff*24;
    }

    DateTimeStamp retDTS=new DateTimeStamp(0,getTimeStampInt(hrDiff,minDiff,secDiff));

    return retDTS;
  }


}
