package track21;

import MainGUI;

import waba.sys.*;

public class GraphOptions
{
  int precision=0;    //default format is int
  public static int DFORMAT_DD_MM_YYYY=0, DFORMAT_MM_DD_YYYY=1;
  static int dmyFormat=DFORMAT_MM_DD_YYYY;

  int xticks=2;
  int yticks=2;
  int gXmin, gXmax;   //julian days
  float gYmin, gYmax;
  boolean xMinAutoScl=true, xMaxAutoScl=true, yMinAutoScl=true, yMaxAutoScl=true;
  boolean xIsRelative=false;
  String xTitle, yTitle, mainTitle;
  public static int GTYPE_LINE=1, GTYPE_BAR=2, GTYPE_DOTS=4;    //bit fields for graph types
  int gType=GTYPE_LINE;
  TrackData td;

  public GraphOptions(TrackData tdIn)
  {
    td=tdIn;
    configProduct();
  }

//  public void setTrackData(TrackData tdIn)
//  {
//    td=tdIn;
//  }

  public int getPrecision()
  {
    return precision;
  }

  public static int calcPrecision(float val)
  {
    int i=0;
    int pow10=1;

    for (i = 0; i < 4; i++)   //max precision is 4
    {
      if((val*pow10)==(int)(val*pow10))
        return i;

      pow10=pow10*10;
    }

    return i;
  }

  public void setPrecision(int precIn)
  {
    precision=precIn;
  }

  public boolean getXisRelative()
  {
    return xIsRelative;
  }

  public void setXisRelative(boolean flagIn)
  {
    xIsRelative=flagIn;
  }

  public int getGraphType()
  {
    return gType;
  }

  public void setGraphType(int gt)
  {
    gType=gt;
  }

  public void setXtitle(String title)
  {
    xTitle=title;
  }

  public String getXtitle()
  {
    return xTitle;
  }

  public void setYtitle(String title)
  {
    yTitle=title;
  }

  public String getYtitle()
  {
    return yTitle;
  }

  public void setMainTitle(String title)
  {
    mainTitle=title;
  }

  public String getMainTitle()
  {
    return mainTitle;
  }

  public static int getDMYformat()
  {
    return dmyFormat;
  }

  public int getXticks()
  {
    return xticks;
  }

  public void setXticks(int tmp)
  {
    xticks=tmp;
  }

  public int getYticks()
  {
    return yticks;
  }

  public void setYticks(int tmp)
  {
    yticks=tmp;
  }

  public int getXmin()
  {
    return gXmin;
  }

  public int getXmax()
  {
    return gXmax;
  }

  public void setXmin(int tmpMin)
  {
    gXmin=tmpMin;
  }

  public void setXmax(int tmpMax)
  {
    gXmax=tmpMax;
  }

  public float getYmin()
  {
    return gYmin;
  }

  public float getYmax()
  {
    return gYmax;
  }

  public void setYmin(float tmpMin)
  {
    gYmin=tmpMin;
  }

  public void setYmax(float tmpMax)
  {
    gYmax=tmpMax;
  }

  public boolean getXminAutoScl()
  {
    return xMinAutoScl;
  }

  public boolean getXmaxAutoScl()
  {
    return xMaxAutoScl;
  }

  public boolean getYminAutoScl()
  {
    return yMinAutoScl;
  }

  public boolean getYmaxAutoScl()
  {
    return yMaxAutoScl;
  }

  public void setXminAutoScl(boolean flag)
  {
    xMinAutoScl=flag;
  }

  public void setXmaxAutoScl(boolean flag)
  {
    xMaxAutoScl=flag;
  }

  public void setYminAutoScl(boolean flag)
  {
    yMinAutoScl=flag;
  }

  public void setYmaxAutoScl(boolean flag)
  {
    yMaxAutoScl=flag;
  }

  public void updateGraphMinMax()
  {
    if(xMaxAutoScl)
      gXmax=td.getDateIntMax();
    if(xMinAutoScl)
      gXmin=td.getDateIntMin();
    if(yMaxAutoScl)
      gYmax=td.getYmax();
    if(yMinAutoScl)
      gYmin=td.getYmin();
  }

  void configProduct()
  {
//    Vm.debug("GO Conf\nProd="+MainGUI.currentProduct);
    switch (MainGUI.currentProduct)
    {
      case MainGUI.PRODUCT_HABIT:
        setYtitle("Count");
        setMainTitle("Habit count by date");
        setYminAutoScl(false);
        setYmin(0f);
        break;
      case MainGUI.PRODUCT_TIMEIT:
        setYtitle("Minutes");
        setMainTitle("Total minutes by date");
        setGraphType(GraphOptions.GTYPE_BAR+GraphOptions.GTYPE_DOTS);
        setXticks(0);
        break;
      case MainGUI.PRODUCT_MONEY:
        break;
      case MainGUI.PRODUCT_STUDENT:
        break;
      case MainGUI.PRODUCT_PLOTIT:
        setYtitle("Value");
        setMainTitle("Value by date");
        setGraphType(GraphOptions.GTYPE_LINE+GraphOptions.GTYPE_DOTS);
        break;
      case MainGUI.PRODUCT_FULL:
        setYtitle("Value");
        setMainTitle("Value by date");
        setGraphType(GraphOptions.GTYPE_LINE+GraphOptions.GTYPE_DOTS);
        break;
    }
    setXtitle("Date");
  }


}
