package track21;

import waba.ui.*;
import waba.util.*;
import waba.sys.*;

public class GraphOptionsWindow extends Window
{
  String alphaNum="abcdefghijklmnopqrstuvwxyz1234567890";
  String numOnly="1234567890.";

  GraphOptions go;
  Edit gXmin, gXmax, gYmin, gYmax, gXticks, gYticks, gPrecision, gXtitle, gYtitle, gMainTitle;
  Check gXMaxAutoScl, gYMaxAutoScl, gXMinAutoScl, gYMinAutoScl, gXisRelative;
  Check gLine, gDot, gBar;
  Button doneButton;
  TrackData td;

  public GraphOptionsWindow(GraphOptions goIn)
  {
    go=goIn;

    add(new Label("Min X:"),LEFT+5,TOP+15);

    gXmin=new Edit();
    add(gXmin);
    gXmin.setRect(35,SAME,50,PREFERRED);
    gXmin.setValidChars(numOnly);

    gXMinAutoScl=new Check("AutoScl");
    add(gXMinAutoScl,AFTER+5,SAME);

    add(new Label("Max X:"),LEFT+5,AFTER+2);

    gXmax=new Edit();
    add(gXmax);
    gXmax.setRect(35,SAME,50,PREFERRED);
    gXmax.setValidChars(numOnly);

    gXMaxAutoScl=new Check("AutoScl");
    add(gXMaxAutoScl,AFTER+5,SAME);

    add(new Label("Min Y:"),LEFT+5,AFTER+2);

    gYmin=new Edit();
    add(gYmin);
    gYmin.setRect(35,SAME,50,PREFERRED);
    gYmin.setValidChars(numOnly);

    gYMinAutoScl=new Check("AutoScl");
    add(gYMinAutoScl,AFTER+5,SAME);

    add(new Label("Max Y:"),LEFT+5,AFTER+2);

    gYmax=new Edit();
    add(gYmax);
    gYmax.setRect(35,SAME,50,PREFERRED);
    gYmax.setValidChars(numOnly);

    gYMaxAutoScl=new Check("AutoScl");
    add(gYMaxAutoScl,AFTER+5,SAME);

    add(new Label("Xtck:"),LEFT+5,AFTER+5);

    gXticks=new Edit();
    add(gXticks);
    gXticks.setRect(AFTER+2,SAME,20,PREFERRED);
    gXticks.setValidChars(numOnly);

    Label yLbl=new Label("Ytck:");
    add(yLbl,AFTER+5,SAME);

    gYticks=new Edit();
    add(gYticks);
    gYticks.setRect(AFTER+2,SAME,20,PREFERRED);
    gYticks.setValidChars(numOnly);

    Label pLbl=new Label("Precis:");
    add(pLbl,AFTER+5,SAME);

    gPrecision=new Edit();
    add(gPrecision);
    gPrecision.setRect(AFTER+2,SAME,20,PREFERRED);
    gPrecision.setValidChars(numOnly);

    gLine=new Check("Line");
    add(gLine,LEFT+5,AFTER+3);
    gBar=new Check("Bar");
    add(gBar,LEFT+5,AFTER+2);
    gDot=new Check("Dot");
    add(gDot,LEFT+5,AFTER+2);

    Label lblXttd=new Label("Xttl:");
    add(lblXttd,gLine.getRect().x2()+4,gLine.getRect().y);

    gXtitle=new Edit();
    add(gXtitle);
    gXtitle.setRect(AFTER+5,SAME,70,PREFERRED);

    add(new Label("Yttl:"),lblXttd.getRect().x,AFTER+2);

    gYtitle=new Edit();
    add(gYtitle);
    gYtitle.setRect(gXtitle.getRect().x,SAME,70,PREFERRED);

    add(new Label("Mttl:"),lblXttd.getRect().x,AFTER+2);

    gMainTitle=new Edit();
    add(gMainTitle);
    gMainTitle.setRect(gXtitle.getRect().x,SAME,70,PREFERRED);

    gXisRelative=new Check("X is Relat.");
    add(gXisRelative,LEFT+5,BOTTOM-2);

    doneButton=new Button("Done");
    add(doneButton,RIGHT-5,SAME);

    loadGUIfromGraphOptions();
  }

  public void onEvent(Event event)
    {
      switch(event.type)
      {
        case ControlEvent.PRESSED:
          if(event.target==doneButton)
          {
            this.unpop();
          }
          break;
      }
    }

  public void loadGUIfromGraphOptions()
  {
    go.updateGraphMinMax();

    gXMaxAutoScl.setChecked(go.getXmaxAutoScl());
    gXMinAutoScl.setChecked(go.getXminAutoScl());
    gYMaxAutoScl.setChecked(go.getYmaxAutoScl());
    gYMinAutoScl.setChecked(go.getYminAutoScl());

    gXmax.setText(Convert.toString(go.getXmax()));
    gXmin.setText(Convert.toString(go.getXmin()));
    gYmax.setText(TrackData.getYvalueStr(go.getYmax(),go.getPrecision()));
    gYmin.setText(TrackData.getYvalueStr(go.getYmin(),go.getPrecision()));

    gXticks.setText(Convert.toString(go.getXticks()));
    gYticks.setText(Convert.toString(go.getYticks()));

    gXisRelative.setChecked(go.getXisRelative());

    gPrecision.setText(Convert.toString(go.getPrecision()));

    gXtitle.setText(go.getXtitle());
    gYtitle.setText(go.getYtitle());
    gMainTitle.setText(go.getMainTitle());

    Vm.debug("Read Gtype="+go.getGraphType());

    if((go.getGraphType()&GraphOptions.GTYPE_LINE)==GraphOptions.GTYPE_LINE)
      gLine.setChecked(true);

    if((go.getGraphType()&GraphOptions.GTYPE_BAR)==GraphOptions.GTYPE_BAR)
      gBar.setChecked(true);

    if((go.getGraphType()&GraphOptions.GTYPE_DOTS)==GraphOptions.GTYPE_DOTS)
      gDot.setChecked(true);
  }

  public void setGraphOptionsFromGUI()
  {
    go.setXmaxAutoScl(gXMaxAutoScl.getChecked());
    go.setXminAutoScl(gXMinAutoScl.getChecked());
    go.setYmaxAutoScl(gYMaxAutoScl.getChecked());
    go.setYminAutoScl(gYMinAutoScl.getChecked());

    go.setXmax(Convert.toInt(gXmax.getText()));
    go.setXmin(Convert.toInt(gXmin.getText()));
    go.setYmax(Convert.toFloat(gYmax.getText()));
    go.setYmin(Convert.toFloat(gYmin.getText()));

    go.setXticks(Convert.toInt(gXticks.getText()));
    go.setYticks(Convert.toInt(gYticks.getText()));

    go.setXisRelative(gXisRelative.getChecked());

    go.setPrecision(Convert.toInt(gPrecision.getText()));

    go.setXtitle(gXtitle.getText());
    go.setYtitle(gYtitle.getText());
    go.setMainTitle(gMainTitle.getText());

    int tmpGtype=0;

    if(gLine.getChecked())
      tmpGtype=tmpGtype+GraphOptions.GTYPE_LINE;

    if(gBar.getChecked())
      tmpGtype=tmpGtype+GraphOptions.GTYPE_BAR;

    if(gDot.getChecked())
      tmpGtype=tmpGtype+GraphOptions.GTYPE_DOTS;

    Vm.debug("Saving Gtype="+tmpGtype);
    go.setGraphType(tmpGtype);
  }

}
