package track21;

import superwaba.ext.palm.io.*;
import superwaba.ext.palm.io.builtin.Memo;

import waba.sys.*;

import java.lang.String;

public class MemoPadIO
{
  Memo m;

  public MemoPadIO()
  {
  }

  public void exportData(String dbName, TrackData td)
  {
    String mText=new String(dbName+"\n");

    mText=mText+td.getGraphOptions().getXtitle()
      +","+td.getGraphOptions().getYtitle()+",[comments]\n";

    for (int i = 0; i < td.getNumPts(); i++)
    {
      mText=mText+td.getDateInt(i)+","+td.getYvalueStr(i)+","+td.getComment(i)+"\n";
    }

    m=new Memo();
    m.text=mText;
    boolean flag=Memo.addMemo(m);

//    if(flag)
//      Vm.debug("Export to Memo succeeded");
//    else
//      Vm.debug("Export to Memo failed");
  }

  public TrackData importData(String dbName)
  {
    TrackData td=new TrackData();

//    Vm.debug("Importing "+dbName+" Mcount="+Memo.memoCount());

    if(Memo.memoCount()==0)
    {
      return null;
    }

/*    for (int i = 0; i < Memo.memoCount(); i++)
    {
      if(Memo.getMemo(i,m));
     {
       Vm.debug("I="+i+" MT="+m.text);
     }
    }
*/
    m=Memo.findMemo(dbName,false);
    if(m==null)
    {
//      Vm.debug("No Match!");
      return null;
    }
//    Vm.debug("MText="+m.text);

    int cPtr0=0,cPtr1=0;
    cPtr0=m.text.indexOf('\n',cPtr0)+1;   //skip past memo title

    cPtr1=m.text.indexOf(',',cPtr0);      //read xtitle
    td.getGraphOptions().setXtitle(m.text.substring(cPtr0,cPtr1));

    cPtr0=cPtr1+1;
    cPtr1=m.text.indexOf(',',cPtr0);      //read ytitle
    td.getGraphOptions().setYtitle(m.text.substring(cPtr0,cPtr1));

    cPtr0=m.text.indexOf('\n',cPtr0)+1;   //skip past comments tag

    td.clearAllData();    //reset numPts to 0

    while (cPtr0<m.text.length())
    {
      cPtr1=m.text.indexOf(',',cPtr0);
      String dateIntStr=m.text.substring(cPtr0,cPtr1);

//      String s1=dateIntStr+"["+cPtr0+","+cPtr1+"]";   //debug Str

      cPtr0=cPtr1+1;
      cPtr1=m.text.indexOf(',',cPtr0);
      String floatValStr=m.text.substring(cPtr0,cPtr1);

//      String s2=floatValStr+"["+cPtr0+","+cPtr1+"]";    //debug Str

      cPtr0=cPtr1+1;
      cPtr1=m.text.indexOf('\n',cPtr0);
      String commentStr=m.text.substring(cPtr0,cPtr1);

//      String s3=commentStr+"["+cPtr0+","+cPtr1+"]";     //debug Str

      cPtr0=cPtr1+1;

//      if(cPtr0<150)
//        Vm.debug(s1+" "+s2+" "+s3);                     //debug Str

//      Vm.debug("1="+dateIntStr+" 2="+floatValStr+" 3="+commentStr);
      td.addData(Convert.toInt(dateIntStr),Convert.toFloat(floatValStr),commentStr);
    }

    return td;
  }

}
